//OPTIONAL: This simple JS-based client might be useful to you for testing/debugging (see simpleDriver.js for a script that calls this)
var rp = require("request-promise");
var fs = require('fs');

module.exports = class MemeClient {

    constructor() {
        this.endpoint = "http://localhost:3000/";
    }

    async addMemeTemplate(template) {
        return rp.post({
            url: this.endpoint + "templates",
            json: template
        });
    }

    async deleteMemeTemplate(template) {
        return rp.delete(this.endpoint + "templates/" + template)
    }

    async uploadTemplateBaseImage(templateName, imgPath) {
        var formData = {
            file: fs.createReadStream(imgPath),
        };

        return rp.put({url: this.endpoint + "templates/"+templateName, formData: formData});
    }

    async getTemplate(templateName) {
        if (templateName) {
            return rp.get(this.endpoint + "templates/" + templateName);
        }
        else {
            return rp.get(this.endpoint + "templates");
        }
    }

    async generateMeme(memeData) {
        return rp.post({
            url: this.endpoint + "memes",
            encoding: null, //NOTE - this is necessary to ensure that the image doesnt become corrupt in translation
            json: memeData
        });
    }
}

