//OPTIONAL: You might find this little script of examples useful for testing and debugging

var memeClient = require("./MemeClient.js");
memeClient = new memeClient();//create an instance
var fs =require("fs");

async function doStuff() {
    await memeClient.addMemeTemplate({
        "Doge": {
            "text": {
                "bottom": {
                    "fillColor": "#FFF",
                    "font": "Impact.ttf",
                    "location": {
                        "gravity": "South",
                        "x": 0,
                        "y": 20
                    },
                    "size": 54,
                    "strokeWidth": 1.5,
                    "strokeColor": "#000"
                },
                "top": {
                    "fillColor": "#FFF",
                    "font": "Impact.ttf",
                    "location": {
                        "gravity": "North",
                        "x": 0,
                        "y": 50
                    },
                    "size": 54,
                    "strokeWidth": 1.5,
                    "strokeColor": "#000"
                }
            }
        }
    });
    await memeClient.addMemeTemplate({
        "Gru": {
            "text": {
                "step1": {
                    "font": "Verdana.ttf",
                    "size": 12,
                    "strokeWidth": 0,
                    "fillColor": "#000000",
                    "strokeColor": "#FFFFFF",
                    "location": {
                        "x": 175,
                        "y": 60,
                        "gravity": null
                    }
                },
                "step2": {
                    "font": "Verdana.ttf",
                    "size": 12,
                    "strokeWidth": 0,
                    "fillColor": "#000000",
                    "strokeColor": "#FFFFFF",
                    "location": {
                        "x": 475,
                        "y": 60,
                        "gravity": null
                    }
                },
                "step3": {
                    "font": "Verdana.ttf",
                    "size": 12,
                    "strokeWidth": 0,
                    "fillColor": "#000000",
                    "strokeColor": "#FFFFFF",
                    "location": {
                        "x": 175,
                        "y": 250,
                        "gravity": null
                    }
                },
                "step4": {
                    "font": "Verdana.ttf",
                    "size": 12,
                    "strokeWidth": 0,
                    "fillColor": "#000000",
                    "strokeColor": "#FFFFFF",
                    "location": {
                        "x": 475,
                        "y": 250,
                        "gravity": null
                    }
                }
            }
        }
   });
    var res = await memeClient.uploadTemplateBaseImage("Doge","resources/doge.jpg");
    await memeClient.uploadTemplateBaseImage("Gru","resources/gru.jpg");
    try {
        var gruMeme = await memeClient.generateMeme({
            memeTemplate: "Gru",
            text: {
                step1: "Make a new NPM\nProject",
                step2: "Generate lots\nof memes",
                step3: "Forget to actually\ndo the\nassignment",
                step4: "Forget to actually\ndo the\nassignment"
            }
        });
        fs.writeFileSync("gru_from_server.png", gruMeme);
    }catch(e){
        console.log(e);
    }
}
doStuff();
